'$DYNAMIC
Option _Explicit

Type Window
    Handle As _Unsigned _Integer64
    iconHandle As _Unsigned _Integer64 '       : ^ Image handles
    Identifier As _Unsigned _Integer64
    Title As String * 20 '                     : < Window title and icon title
    titleTextSize As _Unsigned _Byte '         : Length of title's text
    limitStartPositionX As _Unsigned Integer
    limitStartPositionY As _Unsigned Integer
    limitEndPositionX As _Unsigned Integer
    limitEndPositionY As _Unsigned Integer '   : ^ Limit of where window can be moved
    previousPositionX As _Unsigned Integer
    previousPositionY As _Unsigned Integer
    positionStartX As Integer
    positionStartY As Integer
    minimumWidth As _Unsigned Integer
    minimumHeight As _Unsigned Integer '       : ^ Minimum size of window (usually startwidth)
    startWidth As _Unsigned Integer
    startHeight As _Unsigned Integer '         : ^ Default size of window
    maximumWidth As _Unsigned Integer
    maximumHeight As _Unsigned Integer '       : ^ Maximum size of window
    iconPositionStartX As Integer
    iconPositionStartY As Integer
    iconPositionPreviousX As Integer
    iconPositionPreviousY As Integer
    iconWidth As _Unsigned Integer
    iconHeight As _Unsigned Integer '          : ^ Icon size and position
    iconTitlePositionStartX As Integer
    iconTitlePositionStartY As Integer '       : ^ Icon size and position
    isChild As _Byte
    isDialogBox As _Byte
    isMaximizable As _Byte
    isMinimizable As _Byte
    isMovable As _Byte
    isResizable As _Byte '                     : ^ Window attributes
    isMaximized As _Byte
    isRestored As _Byte
    isMinimized As _Byte
    wasMaximized As _Byte
    wasRestored As _Byte
    isActive As _Byte
    isMoving As _Byte
    isResizing As _Byte
End Type '                : ^ Window Status

Type Button
    startX As _Unsigned Integer
    startY As _Unsigned Integer
    endX As _Unsigned Integer
    endY As _Unsigned Integer
    typeSelector As _Unsigned _Byte
    isPressed As _Byte
End Type

Type Credential
    correctUsername As _Unsigned _Integer64
    correctPassword As _Unsigned _Integer64
End Type

Dim Shared hashTable(1, 95) As _Unsigned Integer
Dim Counter As _Unsigned Integer

Restore positionHash
For Counter = 94 To 0 Step -1
    Read hashTable(1, Counter)
Next Counter

Restore characterHash
For Counter = 0 To 94
    Read hashTable(0, Counter)
Next Counter

'$include: 'colors.bi'

Dim Shared minimumSize As _Unsigned _Byte: minimumSize = 0
Dim Shared ZORDER(minimumSize) As Window, NULL_Window As Window, zOrderInput As Window
Dim Shared maximumSize As _Unsigned _Integer64, currentSize As _Unsigned _Integer64: maximumSize = 0 - 1: currentSize = minimumSize
Dim Shared primaryDisplay As _Unsigned _Integer64: primaryDisplay = setMode(800, 600)
Screen primaryDisplay
goFullscreen (0)

Dim Shared previousMouseX As _Unsigned Integer, mouseX As _Unsigned Integer, currentMouseX As _Unsigned Integer
Dim Shared previousMouseY As _Unsigned Integer, mouseY As _Unsigned Integer, currentMouseY As _Unsigned Integer
Dim Shared mouseButton1 As _Byte, mouseButton2 As _Byte, mouseClicked As _Byte
Dim Shared currentTime As String, currentDate As String

'$include:'default-theme.bi'

Dim Shared numberOfUsers As _Unsigned Integer: numberOfUsers = 4
Dim Shared Username As String
Dim Shared uInput As _Unsigned _Integer64, pInput As _Unsigned _Integer64
Dim Shared Successful As _Bit: Dim Shared User As _Bit, Root As _Bit, Guest As _Bit, New As _Bit
Dim Shared userLevel As _Unsigned Integer

Dim Shared backC As _Unsigned Long, backupBackC As _Unsigned Long: backC = Black
Dim Shared textC As _Unsigned Long, backupTextC As _Unsigned Long: textC = White

Dim Shared errorLevel As _Unsigned _Byte

ReDim Shared loginCredentials(numberOfUsers) As Credential

'
' User code below
'

initializeObjects
loginToOS3
cliMainLoop
System

'
' User code above
'

characterHash:
Data 2,3,5,7,11,13,17,19
Data 23,29,31,37,41,43,47,53
Data 59,61,67,71,73,79,83,89
Data 97,101,103,107,109,113,127,131
Data 137,139,149,151,157,163,167,173
Data 179,181,191,193,197,199,211,223
Data 227,229,233,239,241,251,257,263
Data 269,271,277,281,283,293,307,311
Data 313,317,331,337,347,349,353,359
Data 367,373,379,383,389,397,401,409
Data 419,421,431,433,439,443,449,457
Data 461,463,467,479,487,491,499

positionHash:
Data 9157,9161,9173,9181,9187,9199,9203
Data 9209,9221,9227,9239,9241,9257,9277,9281
Data 9283,9293,9311,9319,9323,9337,9341,9343
Data 9349,9371,9377,9391,9397,9403,9413,9419
Data 9421,9431,9433,9437,9439,9461,9463,9467
Data 9473,9479,9491,9497,9511,9521,9533,9539
Data 9547,9551,9587,9601,9613,9619,9623,9629
Data 9631,9643,9649,9661,9677,9679,9689,9697
Data 9719,9721,9733,9739,9743,9749,9767,9769
Data 9781,9787,9791,9803,9811,9817,9829,9833
Data 9839,9851,9857,9859,9871,9883,9887,9901
Data 9907,9923,9929,9931,9941,9949,9967,9973

'$include :'objects.bi'

Sub cliMainLoop
    KEY 1, UCase$("help") + Chr$(13)
    KEY 2, "" + Chr$(13)
    KEY 3, "" + Chr$(13)
    KEY 4, UCase$("gui") + Chr$(13)
    KEY 5, "" + Chr$(13)
    KEY 6, "" + Chr$(13)
    KEY 7, "" + Chr$(13)
    KEY 8, "" + Chr$(13)
    KEY 9, "" + Chr$(13)
    KEY 10, UCase$("quit") + Chr$(13)
    KEY 30, "" + Chr$(13)
    KEY 31, UCase$("about") + Chr$(13)

    KEY On
    Do
        Dim cmd As String

        If Root Then
            Input "#> ", cmd
        ElseIf User Then
            Input "$> ", cmd
        ElseIf Guest Then
            Input "%> ", cmd
        End If

        Dim cmdHash As _Unsigned _Integer64
        cmdHash = Encode(LTrim$(RTrim$(UCase$(cmd))))

        If cmdHash = Encode("DEBUG") Then
            Rem
        End If

        If cmdHash = Encode("DATE") Then
            Print ""
            Print "The current date is: " + Date$
            Print ""
        End If

        If cmdHash = Encode("TIME") Then
            Print ""
            Print "The current time is: " + Time$
            Print ""
        End If

        If cmdHash = Encode("CLS") Then
            Cls
        End If

        If cmdHash = Encode("BYE") Then
            System
        End If

        If cmdHash = Encode("HELP") Then
            Print ""
            Print "Available Commands: "
            Print ""
            Print "date, time, cls, bye, about, help, debug, gui"
            Print ""
        End If

        If cmd = "2" Then
            Rem
        End If

        If cmd = "3" Then
            Rem
        End If

        If cmdHash = Encode("GUI") Then
            Call guiMainLoop
        End If

        If cmd = "5" Then
            Rem
        End If

        If cmd = "6" Then
            Rem
        End If

        If cmd = "7" Then
            Rem
        End If

        If cmd = "8" Then
            Rem
        End If

        If cmd = "9" Then
            Rem
        End If

        If cmd = "QUIT" Then
            System
        End If

        If cmd = "30" Then
        End If

        If cmd = "ABOUT" Or cmdHash = Encode("ABOUT") Then
            Print ""
            Print "OS/3 Master Control Program"
            Print "Version 0.99a"
            Print ""
            Print "Keybonic Plague (Keybone) - 09/20/2017"
            Print ""
        End If
    Loop
    KEY Off
    End
End Sub

Sub guiMainLoop
    Dim Iteration As _Unsigned _Integer64
    While currentSize > minimumSize
        bgPlace
        probeMouse
        For Iteration = currentSize To minimumSize + 1 Step -1
            If mouseButton1 Then
                If isWithinWindow(Iteration) Then
                    If ZORDER(Iteration).isMinimized Then
                        restoreWindow (Iteration)
                        Exit For
                    ElseIf ZORDER(Iteration).isRestored Then
                        raiseToTop (Iteration)
                        If isWithinArea(Iteration, 4, 4, 21, 21) Then
                            removeFromZOrder (Iteration)
                            If Iteration > minimumSize + 1 Then raiseToTop (Iteration - 1)
                            Exit For
                        ElseIf isWithinArea(Iteration, 22, 4, ZORDER(Iteration).startWidth - 42, 21) Then
                            moveWindow (Iteration)
                        ElseIf isWithinArea(Iteration, ZORDER(Iteration).startWidth - 41, 4, ZORDER(Iteration).startWidth - 24, 21) Then
                            If ZORDER(Iteration).isMinimizable Then
                                minimizeWindow (Iteration)
                                If Iteration > minimumSize + 1 Then raiseToTop (Iteration - 1)
                            End If
                        ElseIf isWithinArea(Iteration, ZORDER(Iteration).startWidth - 22, 4, ZORDER(Iteration).startWidth - 5, 21) Then
                            maximizeWindow (Iteration)
                        ElseIf isWithinArea(Iteration, ZORDER(Iteration).startWidth - 22, ZORDER(Iteration).startHeight - 22, ZORDER(Iteration).startWidth - 5, ZORDER(Iteration).startHeight - 5) Then
                            resizeWindow (Iteration)
                        End If
                        checkInterface (Iteration)
                    ElseIf ZORDER(Iteration).isMaximized Then
                        If isWithinArea(Iteration, 4, 4, 21, 21) Then
                            removeFromZOrder (Iteration)
                            Exit For
                        ElseIf isWithinArea(Iteration, ZORDER(Iteration).maximumWidth - 41, 4, ZORDER(Iteration).maximumWidth - 24, 21) Then
                            minimizeWindow (Iteration)
                            If Iteration > minimumSize + 1 Then raiseToTop (Iteration - 1)
                        ElseIf isWithinArea(Iteration, ZORDER(Iteration).maximumWidth - 22, 4, ZORDER(Iteration).maximumWidth - 5, 21) Then
                            restoreWindow (Iteration)
                        End If
                        checkInterface (Iteration)
                    End If
                    Exit For
                End If
            End If
        Next Iteration
        updateDisplay
        _Display
    Wend
    switchToCLI
End Sub

Sub loginToOS3
    loginCredentials(0).correctUsername = 41017948: loginCredentials(0).correctPassword = 140956205
    loginCredentials(1).correctUsername = 47269231: loginCredentials(1).correctPassword = 0
    loginCredentials(2).correctUsername = 11224770: loginCredentials(2).correctPassword = 0
    restartlogin:
    While Successful <> -1
        UsernameInput
        If uInput <> 47269231 Then
            If uInput <> 11224770 Then
                PasswordInput
            End If
        End If
        If uInput = loginCredentials(0).correctUsername Then If pInput = loginCredentials(0).correctPassword Then Root = -1: Successful = -1
        If uInput = loginCredentials(1).correctUsername Then Guest = -1: Successful = -1
        If uInput = loginCredentials(2).correctUsername Then New = -1: Successful = -1
        If Successful = -1 Then
            Cls
        Else
            errorLevel = 6
            errorHandler
        End If
    Wend
    If New = -1 Then userLevel = 1: makeUser
    If Guest = -1 Then userLevel = 2: Print "Hello, " + RTrim$(LTrim$(Username)) + "!": Print ""
    If User = -1 Then userLevel = 4: Print "Hello, " + RTrim$(LTrim$(Username)) + "!": Print ""
    If Root = -1 Then userLevel = 8: Print "Hello, " + RTrim$(LTrim$(Username)) + "!": Print ""
End Sub

Sub UsernameInput
    uInput = 0
    While uInput = 0
        Input "username> ", Username
        uInput = Encode(LTrim$(RTrim$(UCase$(Username))))
    Wend
End Sub

Sub PasswordInput
    pInput = 0
    While pInput = 0
        Print "password> ";
        Dim Password As String: Color backC: Input "", Password: Color textC
        pInput = Encode(LTrim$(RTrim$(Password)))
    Wend
End Sub

Sub makeUser
    numberOfUsers = numberOfUsers + 1
    ReDim _Preserve loginCredentials(numberOfUsers) As Credential
    UsernameInput
    loginCredentials(numberOfUsers).correctUsername = uInput
    Print ""
    PasswordInput
    loginCredentials(numberOfUsers).correctPassword = pInput
    Print loginCredentials(numberOfUsers).correctUsername
    Print loginCredentials(numberOfUsers).correctPassword
    End
End Sub

Sub errorHandler
    If errorLevel = 0 Then GoTo noError
    Beep: Print ""
    If errorLevel = 1 Then Print "ERROR: Invalid Commandname! (Code 1)"
    If errorLevel = 2 Then Print "ERROR: Buffer is Empty! (Code 2)"
    If errorLevel = 3 Then Print "ERROR: SQ Overflow! (Code 3)"
    If errorLevel = 4 Then Print "ERROR: SQ Underflow! (Code 4)"
    If errorLevel = 5 Then Print "ERROR: SQ is Empty! (Code 5)"
    If errorLevel = 6 Then Print "ERROR: Invalid username or password! (Code 6)"
    Print "": errorLevel = 0
    noError:
End Sub

Function Encode~&& (stringInput As String)
    Dim stringLength, characterPosition As _Unsigned Integer
    Dim currentCharacter As String
    Dim encode1 As _Unsigned _Integer64
    stringInput = LTrim$(RTrim$(stringInput))
    stringLength = Len(stringInput)
    For characterPosition = 0 To stringLength
        currentCharacter = Mid$(stringInput, characterPosition, 1)
        Select Case currentCharacter
            Case Chr$(&O040)
                encode1 = encode1 + (hashTable(0, 83) * (hashTable(1, 63) * characterPosition))
            Case Chr$(&O041)
                encode1 = encode1 + (hashTable(0, 33) * (hashTable(1, 53) * characterPosition))
            Case Chr$(&O042)
                encode1 = encode1 + (hashTable(0, 23) * (hashTable(1, 58) * characterPosition))
            Case Chr$(&O043)
                encode1 = encode1 + (hashTable(0, 90) * (hashTable(1, 6) * characterPosition))
            Case Chr$(&O044)
                encode1 = encode1 + (hashTable(0, 59) * (hashTable(1, 71) * characterPosition))
            Case Chr$(&O045)
                encode1 = encode1 + (hashTable(0, 34) * (hashTable(1, 8) * characterPosition))
            Case Chr$(&O046)
                encode1 = encode1 + (hashTable(0, 12) * (hashTable(1, 69) * characterPosition))
            Case Chr$(&O047)
                encode1 = encode1 + (hashTable(0, 94) * (hashTable(1, 37) * characterPosition))
            Case Chr$(&O050)
                encode1 = encode1 + (hashTable(0, 30) * (hashTable(1, 62) * characterPosition))
            Case Chr$(&O051)
                encode1 = encode1 + (hashTable(0, 66) * (hashTable(1, 93) * characterPosition))
            Case Chr$(&O052)
                encode1 = encode1 + (hashTable(0, 14) * (hashTable(1, 9) * characterPosition))
            Case Chr$(&O053)
                encode1 = encode1 + (hashTable(0, 75) * (hashTable(1, 49) * characterPosition))
            Case Chr$(&O054)
                encode1 = encode1 + (hashTable(0, 15) * (hashTable(1, 51) * characterPosition))
            Case Chr$(&O055)
                encode1 = encode1 + (hashTable(0, 36) * (hashTable(1, 14) * characterPosition))
            Case Chr$(&O056)
                encode1 = encode1 + (hashTable(0, 20) * (hashTable(1, 84) * characterPosition))
            Case Chr$(&O057)
                encode1 = encode1 + (hashTable(0, 46) * (hashTable(1, 85) * characterPosition))
            Case Chr$(&O060)
                encode1 = encode1 + (hashTable(0, 21) * (hashTable(1, 48) * characterPosition))
            Case Chr$(&O061)
                encode1 = encode1 + (hashTable(0, 45) * (hashTable(1, 64) * characterPosition))
            Case Chr$(&O062)
                encode1 = encode1 + (hashTable(0, 40) * (hashTable(1, 29) * characterPosition))
            Case Chr$(&O063)
                encode1 = encode1 + (hashTable(0, 85) * (hashTable(1, 30) * characterPosition))
            Case Chr$(&O064)
                encode1 = encode1 + (hashTable(0, 56) * (hashTable(1, 19) * characterPosition))
            Case Chr$(&O065)
                encode1 = encode1 + (hashTable(0, 2) * (hashTable(1, 87) * characterPosition))
            Case Chr$(&O066)
                encode1 = encode1 + (hashTable(0, 35) * (hashTable(1, 10) * characterPosition))
            Case Chr$(&O067)
                encode1 = encode1 + (hashTable(0, 16) * (hashTable(1, 75) * characterPosition))
            Case Chr$(&O070)
                encode1 = encode1 + (hashTable(0, 7) * (hashTable(1, 27) * characterPosition))
            Case Chr$(&O071)
                encode1 = encode1 + (hashTable(0, 69) * (hashTable(1, 76) * characterPosition))
            Case Chr$(&O072)
                encode1 = encode1 + (hashTable(0, 0) * (hashTable(1, 3) * characterPosition))
            Case Chr$(&O073)
                encode1 = encode1 + (hashTable(0, 58) * (hashTable(1, 31) * characterPosition))
            Case Chr$(&O074)
                encode1 = encode1 + (hashTable(0, 55) * (hashTable(1, 65) * characterPosition))
            Case Chr$(&O075)
                encode1 = encode1 + (hashTable(0, 18) * (hashTable(1, 17) * characterPosition))
            Case Chr$(&O076)
                encode1 = encode1 + (hashTable(0, 5) * (hashTable(1, 77) * characterPosition))
            Case Chr$(&O077)
                encode1 = encode1 + (hashTable(0, 4) * (hashTable(1, 12) * characterPosition))
            Case Chr$(&O100)
                encode1 = encode1 + (hashTable(0, 52) * (hashTable(1, 61) * characterPosition))
            Case Chr$(&O101)
                encode1 = encode1 + (hashTable(0, 65) * (hashTable(1, 2) * characterPosition))
            Case Chr$(&O102)
                encode1 = encode1 + (hashTable(0, 43) * (hashTable(1, 7) * characterPosition))
            Case Chr$(&O103)
                encode1 = encode1 + (hashTable(0, 53) * (hashTable(1, 67) * characterPosition))
            Case Chr$(&O104)
                encode1 = encode1 + (hashTable(0, 76) * (hashTable(1, 72) * characterPosition))
            Case Chr$(&O105)
                encode1 = encode1 + (hashTable(0, 79) * (hashTable(1, 25) * characterPosition))
            Case Chr$(&O106)
                encode1 = encode1 + (hashTable(0, 81) * (hashTable(1, 78) * characterPosition))
            Case Chr$(&O107)
                encode1 = encode1 + (hashTable(0, 74) * (hashTable(1, 74) * characterPosition))
            Case Chr$(&O110)
                encode1 = encode1 + (hashTable(0, 60) * (hashTable(1, 11) * characterPosition))
            Case Chr$(&O111)
                encode1 = encode1 + (hashTable(0, 28) * (hashTable(1, 73) * characterPosition))
            Case Chr$(&O112)
                encode1 = encode1 + (hashTable(0, 87) * (hashTable(1, 28) * characterPosition))
            Case Chr$(&O113)
                encode1 = encode1 + (hashTable(0, 10) * (hashTable(1, 79) * characterPosition))
            Case Chr$(&O114)
                encode1 = encode1 + (hashTable(0, 26) * (hashTable(1, 34) * characterPosition))
            Case Chr$(&O115)
                encode1 = encode1 + (hashTable(0, 70) * (hashTable(1, 54) * characterPosition))
            Case Chr$(&O116)
                encode1 = encode1 + (hashTable(0, 11) * (hashTable(1, 55) * characterPosition))
            Case Chr$(&O117)
                encode1 = encode1 + (hashTable(0, 82) * (hashTable(1, 36) * characterPosition))
            Case Chr$(&O120)
                encode1 = encode1 + (hashTable(0, 1) * (hashTable(1, 38) * characterPosition))
            Case Chr$(&O121)
                encode1 = encode1 + (hashTable(0, 67) * (hashTable(1, 40) * characterPosition))
            Case Chr$(&O122)
                encode1 = encode1 + (hashTable(0, 41) * (hashTable(1, 26) * characterPosition))
            Case Chr$(&O123)
                encode1 = encode1 + (hashTable(0, 22) * (hashTable(1, 0) * characterPosition))
            Case Chr$(&O124)
                encode1 = encode1 + (hashTable(0, 92) * (hashTable(1, 57) * characterPosition))
            Case Chr$(&O125)
                encode1 = encode1 + (hashTable(0, 61) * (hashTable(1, 88) * characterPosition))
            Case Chr$(&O126)
                encode1 = encode1 + (hashTable(0, 9) * (hashTable(1, 68) * characterPosition))
            Case Chr$(&O127)
                encode1 = encode1 + (hashTable(0, 25) * (hashTable(1, 50) * characterPosition))
            Case Chr$(&O130)
                encode1 = encode1 + (hashTable(0, 84) * (hashTable(1, 59) * characterPosition))
            Case Chr$(&O131)
                encode1 = encode1 + (hashTable(0, 39) * (hashTable(1, 44) * characterPosition))
            Case Chr$(&O132)
                encode1 = encode1 + (hashTable(0, 17) * (hashTable(1, 16) * characterPosition))
            Case Chr$(&O133)
                encode1 = encode1 + (hashTable(0, 73) * (hashTable(1, 13) * characterPosition))
            Case Chr$(&O134)
                encode1 = encode1 + (hashTable(0, 57) * (hashTable(1, 60) * characterPosition))
            Case Chr$(&O135)
                encode1 = encode1 + (hashTable(0, 78) * (hashTable(1, 23) * characterPosition))
            Case Chr$(&O136)
                encode1 = encode1 + (hashTable(0, 31) * (hashTable(1, 83) * characterPosition))
            Case Chr$(&O137)
                encode1 = encode1 + (hashTable(0, 63) * (hashTable(1, 5) * characterPosition))
            Case Chr$(&O140)
                encode1 = encode1 + (hashTable(0, 37) * (hashTable(1, 22) * characterPosition))
            Case Chr$(&O141)
                encode1 = encode1 + (hashTable(0, 47) * (hashTable(1, 91) * characterPosition))
            Case Chr$(&O142)
                encode1 = encode1 + (hashTable(0, 51) * (hashTable(1, 52) * characterPosition))
            Case Chr$(&O143)
                encode1 = encode1 + (hashTable(0, 80) * (hashTable(1, 47) * characterPosition))
            Case Chr$(&O144)
                encode1 = encode1 + (hashTable(0, 49) * (hashTable(1, 35) * characterPosition))
            Case Chr$(&O145)
                encode1 = encode1 + (hashTable(0, 89) * (hashTable(1, 32) * characterPosition))
            Case Chr$(&O146)
                encode1 = encode1 + (hashTable(0, 24) * (hashTable(1, 94) * characterPosition))
            Case Chr$(&O147)
                encode1 = encode1 + (hashTable(0, 91) * (hashTable(1, 86) * characterPosition))
            Case Chr$(&O150)
                encode1 = encode1 + (hashTable(0, 86) * (hashTable(1, 20) * characterPosition))
            Case Chr$(&O151)
                encode1 = encode1 + (hashTable(0, 42) * (hashTable(1, 39) * characterPosition))
            Case Chr$(&O152)
                encode1 = encode1 + (hashTable(0, 68) * (hashTable(1, 66) * characterPosition))
            Case Chr$(&O153)
                encode1 = encode1 + (hashTable(0, 62) * (hashTable(1, 1) * characterPosition))
            Case Chr$(&O154)
                encode1 = encode1 + (hashTable(0, 50) * (hashTable(1, 42) * characterPosition))
            Case Chr$(&O155)
                encode1 = encode1 + (hashTable(0, 6) * (hashTable(1, 18) * characterPosition))
            Case Chr$(&O156)
                encode1 = encode1 + (hashTable(0, 3) * (hashTable(1, 41) * characterPosition))
            Case Chr$(&O157)
                encode1 = encode1 + (hashTable(0, 88) * (hashTable(1, 56) * characterPosition))
            Case Chr$(&O160)
                encode1 = encode1 + (hashTable(0, 29) * (hashTable(1, 21) * characterPosition))
            Case Chr$(&O161)
                encode1 = encode1 + (hashTable(0, 54) * (hashTable(1, 46) * characterPosition))
            Case Chr$(&O162)
                encode1 = encode1 + (hashTable(0, 71) * (hashTable(1, 90) * characterPosition))
            Case Chr$(&O163)
                encode1 = encode1 + (hashTable(0, 32) * (hashTable(1, 4) * characterPosition))
            Case Chr$(&O164)
                encode1 = encode1 + (hashTable(0, 72) * (hashTable(1, 24) * characterPosition))
            Case Chr$(&O165)
                encode1 = encode1 + (hashTable(0, 13) * (hashTable(1, 33) * characterPosition))
            Case Chr$(&O166)
                encode1 = encode1 + (hashTable(0, 8) * (hashTable(1, 45) * characterPosition))
            Case Chr$(&O167)
                encode1 = encode1 + (hashTable(0, 77) * (hashTable(1, 70) * characterPosition))
            Case Chr$(&O170)
                encode1 = encode1 + (hashTable(0, 19) * (hashTable(1, 92) * characterPosition))
            Case Chr$(&O171)
                encode1 = encode1 + (hashTable(0, 93) * (hashTable(1, 80) * characterPosition))
            Case Chr$(&O172)
                encode1 = encode1 + (hashTable(0, 38) * (hashTable(1, 82) * characterPosition))
            Case Chr$(&O173)
                encode1 = encode1 + (hashTable(0, 64) * (hashTable(1, 89) * characterPosition))
            Case Chr$(&O174)
                encode1 = encode1 + (hashTable(0, 44) * (hashTable(1, 15) * characterPosition))
            Case Chr$(&O175)
                encode1 = encode1 + (hashTable(0, 27) * (hashTable(1, 81) * characterPosition))
            Case Chr$(&O176)
                encode1 = encode1 + (hashTable(0, 48) * (hashTable(1, 43) * characterPosition))
            Case Else
                Rem
        End Select
    Next characterPosition
    Encode = encode1
End Function

Sub sendToClipboard (toClipboard As String)
    _Clipboard$ = toClipboard
    Let toClipboard = ""
End Sub

Function getFromClipboard$
    Let getFromClipboard = ""
    Let getFromClipboard = _Clipboard$
End Function

Function setMode~&& (resolutionX As _Unsigned Integer, resolutionY As _Unsigned Integer)
    If resolutionX = 0 And resolutionY = 0 Then
        setMode = _NewImage(_DesktopWidth, _DesktopHeight, 32)
    ElseIf resolutionX = 0 Or resolutionY = 0 Then
        If resolutionX = 0 Then
            setMode = _NewImage(_DesktopWidth, resolutionY, 32)
        ElseIf resolutionY = 0 Then
            setMode = _NewImage(resolutionX, _DesktopHeight, 32)
        End If
    ElseIf resolutionX <> 0 And resolutionY <> 0 Then
        setMode = _NewImage(resolutionX, resolutionY, 32)
    End If
End Function

Sub goFullscreen (screenOption As _Unsigned _Byte)
    Select Case screenOption
        Case Is = 0
            _PrintMode _KeepBackground
            Exit Sub
        Case Is = 1
            _PrintMode _KeepBackground
            _FullScreen _SquarePixels
        Case Is = 2
            _PrintMode _KeepBackground
            _FullScreen
    End Select
End Sub

Sub probeMouse
    previousMouseX = mouseX
    previousMouseY = mouseY
    While _MouseInput
        mouseButton1 = _MouseButton(1)
        mouseButton2 = _MouseButton(2)
        mouseX = _MouseX
        mouseY = _MouseY
    Wend
    currentMouseX = mouseX
    currentMouseY = mouseY
End Sub

Function isWithinWindow%% (Identifier As _Unsigned _Integer64)
    isWithinWindow = 0
    If ZORDER(Identifier).isRestored = -1 Then
        If currentMouseX >= ZORDER(Identifier).positionStartX Then
            If currentMouseY >= ZORDER(Identifier).positionStartY Then
                If currentMouseX <= ZORDER(Identifier).positionStartX + ZORDER(Identifier).startWidth Then
                    If currentMouseY <= ZORDER(Identifier).positionStartY + ZORDER(Identifier).startHeight Then
                        isWithinWindow = -1
                    End If
                End If
            End If
        End If
    ElseIf ZORDER(Identifier).isMaximized = -1 Then
        If currentMouseX >= 0 Then
            If currentMouseY >= 0 Then
                If currentMouseX <= ZORDER(Identifier).maximumWidth Then
                    If currentMouseY <= ZORDER(Identifier).maximumHeight Then
                        isWithinWindow = -1
                    End If
                End If
            End If
        End If
    ElseIf ZORDER(Identifier).isMinimized = -1 Then
        If currentMouseX >= ZORDER(Identifier).iconPositionStartX Then
            If currentMouseY >= ZORDER(Identifier).iconPositionStartY Then
                If currentMouseX <= ZORDER(Identifier).iconPositionStartX + ZORDER(Identifier).iconWidth Then
                    If currentMouseY <= ZORDER(Identifier).iconPositionStartY + ZORDER(Identifier).iconHeight Then
                        isWithinWindow = -1
                    End If
                End If
            End If
        End If
    End If
End Function

Function isWithinArea%% (Identifier As _Unsigned _Integer64, startX As _Unsigned Integer, startY As _Unsigned Integer, endX As _Unsigned Integer, endY As _Unsigned Integer)
    If ZORDER(Identifier).isRestored = -1 Then
        If currentMouseX >= (ZORDER(Identifier).positionStartX + startX) Then
            If currentMouseY >= (ZORDER(Identifier).positionStartY + startY) Then
                If currentMouseX <= (ZORDER(Identifier).positionStartX + endX) Then
                    If currentMouseY <= (ZORDER(Identifier).positionStartY + endY) Then
                        isWithinArea = -1
                    End If
                End If
            End If
        End If
    ElseIf ZORDER(Identifier).isMaximized = -1 Then
        If currentMouseX >= startX Then
            If currentMouseY >= startY Then
                If currentMouseX <= endX Then
                    If currentMouseY <= endY Then
                        isWithinArea = -1
                    End If
                End If
            End If
        End If
    End If
End Function

Sub bgSolidColor (R As _Unsigned _Byte, G As _Unsigned _Byte, B As _Unsigned _Byte)
    Line (0, 0)-(_Width, _Height), _RGBA32(R, G, B, 255), BF
End Sub

Sub bgImage (backgroundImageName As String)
    Static oldBackgroundImageName As String
    If backgroundImageName <> oldBackgroundImageName Then
        Static bgHandle As Long
        bgHandle = _LoadImage(backgroundImageName)
    End If
    _PutImage (0, 0)-(_Width, _Height), bgHandle, 0, (0, 0)-(_Width, _Height)
    oldBackgroundImageName = backgroundImageName
End Sub

Sub bgImageTiled (backgroundImageName As String)
    Static oldBackgroundImageName As String
    If backgroundImageName <> oldBackgroundImageName Then
        Static tileHandle As _Unsigned _Integer64
        tileHandle = _LoadImage(backgroundImageName)
        Static tileWidth As _Unsigned Integer
        tileWidth = _Width(tileHandle)
        Static tileHeight As _Unsigned Integer
        tileHeight = _Height(tileHandle)
        Static numberWide As Single
        numberWide = _Width \ tileWidth
        Static numberHigh As Single
        numberHigh = _Height \ tileHeight
        Dim currentDesktopHigh As _Unsigned Integer
        Dim currentDesktopWide As _Unsigned Integer
    End If
    For currentDesktopHigh = 0 To numberHigh
        For currentDesktopWide = 0 To numberWide
            _PutImage (tileWidth * currentDesktopWide, tileHeight * currentDesktopHigh), tileHandle, 0
        Next currentDesktopWide
    Next currentDesktopHigh
    oldBackgroundImageName = backgroundImageName
End Sub

Sub bgImageScaled (backgroundImageName As String)
    Static oldBackgroundImageName As String
    If backgroundImageName <> oldBackgroundImageName Then
        Static bgHandle As Long
        bgHandle = _LoadImage(backgroundImageName)
    End If
    _PutImage , bgHandle
    oldBackgroundImageName = backgroundImageName
End Sub

Sub bgPlace
    bgImageScaled "./cloudswide.bmp"
End Sub

Sub addToZOrder
    If currentSize < maximumSize Then
        currentSize = currentSize + 1
        ReDim _Preserve ZORDER(currentSize) As Window
    End If
    ZORDER(currentSize) = zOrderInput
    zOrderInput = NULL_Window
End Sub

Sub removeFromZOrder (Identifier As _Unsigned _Integer64)
    Dim Iteration As _Unsigned _Integer64
    For Iteration = Identifier To currentSize
        If Iteration < currentSize Then ZORDER(Iteration) = ZORDER(Iteration + 1)
    Next Iteration
    If currentSize > minimumSize Then
        currentSize = currentSize - 1
        ReDim _Preserve ZORDER(currentSize) As Window
    End If
End Sub

Sub raiseToTop (Identifier As _Unsigned _Integer64)
    Dim Temporary As Window
    Dim Iteration As _Integer64
    For Iteration = minimumSize + 1 To currentSize
        ZORDER(Iteration).isActive = 0
        displayWindow (Iteration)
    Next Iteration
    Temporary = ZORDER(Identifier)
    For Iteration = Identifier To currentSize
        If Iteration >= Identifier And Iteration < currentSize Then ZORDER(Iteration) = ZORDER(Iteration + 1)
    Next Iteration
    ZORDER(currentSize) = Temporary
    makeActive
End Sub

Sub makeActive
    Dim Iteration As _Integer64
    For Iteration = minimumSize + 1 To currentSize
        ZORDER(Iteration).isActive = 0
        displayWindow (Iteration)
    Next Iteration
    ZORDER(currentSize).isActive = -1
    displayWindow (currentSize)
End Sub

Sub displayWindow (Identifier As _Unsigned _Integer64)
    _Dest ZORDER(Identifier).Handle
    _PrintMode _KeepBackground
    If ZORDER(Identifier).isActive = -1 Then
        Color whiteColor
    Else
        Color blackColor
    End If
    Dim Centering As _Unsigned Integer
    If ZORDER(Identifier).isMaximized = -1 And ZORDER(Identifier).isDialogBox = 0 Then
        Line (0, 0)-(ZORDER(Identifier).maximumWidth - 1, ZORDER(Identifier).maximumHeight - 1), blackColor, B
        Line (1, 1)-(ZORDER(Identifier).maximumWidth - 2, ZORDER(Identifier).maximumHeight - 2), highlightColor2, B
        Line (2, 2)-(ZORDER(Identifier).maximumWidth - 2, ZORDER(Identifier).maximumHeight - 2), shadowColor2, B
        Line (2, 2)-(ZORDER(Identifier).maximumWidth - 3, ZORDER(Identifier).maximumHeight - 3), highlightColor, B
        Line (3, 3)-(ZORDER(Identifier).maximumWidth - 3, ZORDER(Identifier).maximumHeight - 3), shadowColor, B
        Line (3, 3)-(ZORDER(Identifier).maximumWidth - 4, ZORDER(Identifier).maximumHeight - 4), blackColor, B
        Line (0, ZORDER(Identifier).maximumHeight - 23)-(3, ZORDER(Identifier).maximumHeight - 23), blackColor
        Line (23, ZORDER(Identifier).maximumHeight - 3)-(23, ZORDER(Identifier).maximumHeight), blackColor
        Line (ZORDER(Identifier).maximumWidth, ZORDER(Identifier).maximumHeight - 23)-(ZORDER(Identifier).maximumWidth - 3, ZORDER(Identifier).maximumHeight - 23), blackColor
        Line (ZORDER(Identifier).maximumWidth - 23, ZORDER(Identifier).maximumHeight - 3)-(ZORDER(Identifier).maximumWidth - 23, ZORDER(Identifier).maximumHeight), blackColor
        Line (4, 4)-(ZORDER(Identifier).maximumWidth - 5, ZORDER(Identifier).maximumHeight - 5), windowBackgroundColor, BF
        If ZORDER(Identifier).isActive = -1 Then
            Line (4, 4)-(ZORDER(Identifier).maximumWidth - 6, 21), activeTitlebarColor, BF
        Else
            Line (4, 4)-(ZORDER(Identifier).maximumWidth - 6, 21), inactiveTitlebarColor, BF
        End If
        Line (ZORDER(Identifier).maximumWidth - 23, 0)-(ZORDER(Identifier).maximumWidth - 1, 22), blackColor, B
        Line (ZORDER(Identifier).maximumWidth - 42, 3)-(ZORDER(Identifier).maximumWidth - 23, 22), blackColor, B
        Line (0, 0)-(22, 22), blackColor, B
        Line (0, 22)-(ZORDER(Identifier).maximumWidth - 1, 22), blackColor
        Call displayButton(4, 4, 21, 21, 5, 0)
        Call displayButton(ZORDER(Identifier).maximumWidth - 41, 4, ZORDER(Identifier).maximumWidth - 24, 21, 3, 0)
        Centering = (ZORDER(Identifier).maximumWidth - (60 + ZORDER(Identifier).titleTextSize)) / 2
        _PrintString (Centering + 20, 5), ZORDER(Identifier).Title
        If ZORDER(Identifier).isMaximized = 0 Then
            Call displayButton(ZORDER(Identifier).maximumWidth - 22, 4, ZORDER(Identifier).maximumWidth - 5, 21, 1, 0)
        ElseIf ZORDER(Identifier).isMaximized = -1 Then
            Call displayButton(ZORDER(Identifier).maximumWidth - 22, 4, ZORDER(Identifier).maximumWidth - 5, 21, 2, 0)
        End If
    ElseIf ZORDER(Identifier).isMaximized = 0 And ZORDER(Identifier).isDialogBox = 0 And ZORDER(Identifier).isMinimized = 0 Then
        Line (0, 0)-(ZORDER(Identifier).startWidth - 1, ZORDER(Identifier).startHeight - 1), blackColor, B
        Line (1, 1)-(ZORDER(Identifier).startWidth - 2, ZORDER(Identifier).startHeight - 2), highlightColor2, B
        Line (2, 2)-(ZORDER(Identifier).startWidth - 2, ZORDER(Identifier).startHeight - 2), shadowColor2, B
        Line (2, 2)-(ZORDER(Identifier).startWidth - 3, ZORDER(Identifier).startHeight - 3), highlightColor, B
        Line (3, 3)-(ZORDER(Identifier).startWidth - 3, ZORDER(Identifier).startHeight - 3), shadowColor, B
        Line (3, 3)-(ZORDER(Identifier).startWidth - 4, ZORDER(Identifier).startHeight - 4), blackColor, B
        Line (0, ZORDER(Identifier).startHeight - 23)-(3, ZORDER(Identifier).startHeight - 23), blackColor
        Line (23, ZORDER(Identifier).startHeight - 3)-(23, ZORDER(Identifier).startHeight), blackColor
        If ZORDER(Identifier).isResizable = 0 Then
            Line (ZORDER(Identifier).startWidth, ZORDER(Identifier).startHeight - 23)-(ZORDER(Identifier).startWidth - 3, ZORDER(Identifier).startHeight - 23), blackColor
            Line (ZORDER(Identifier).startWidth - 23, ZORDER(Identifier).startHeight - 3)-(ZORDER(Identifier).startWidth - 23, ZORDER(Identifier).startHeight), blackColor
        End If
        Line (4, 4)-(ZORDER(Identifier).startWidth - 5, ZORDER(Identifier).startHeight - 5), windowBackgroundColor, BF
        If ZORDER(Identifier).isActive = -1 Then
            Line (4, 4)-(ZORDER(Identifier).startWidth - 6, 21), activeTitlebarColor, BF
        Else
            Line (4, 4)-(ZORDER(Identifier).startWidth - 6, 21), inactiveTitlebarColor, BF
        End If
        Line (ZORDER(Identifier).startWidth - 23, 0)-(ZORDER(Identifier).startWidth - 1, 22), blackColor, B
        Line (ZORDER(Identifier).startWidth - 42, 3)-(ZORDER(Identifier).startWidth - 23, 22), blackColor, B
        Line (0, 0)-(22, 22), blackColor, B
        Line (0, 22)-(ZORDER(Identifier).startWidth - 1, 22), blackColor
        If ZORDER(Identifier).isChild = -1 Then
            Call displayButton(4, 4, 21, 21, 6, 0)
        Else
            Call displayButton(4, 4, 21, 21, 5, 0)
        End If
        Call displayButton(ZORDER(Identifier).startWidth - 41, 4, ZORDER(Identifier).startWidth - 24, 21, 3, 0)
        Centering = (ZORDER(Identifier).startWidth - (60 + ZORDER(Identifier).titleTextSize)) / 2
        _PrintString (Centering + 20, 5), ZORDER(Identifier).Title
        If ZORDER(Identifier).isMaximized = 0 Then
            Call displayButton(ZORDER(Identifier).startWidth - 22, 4, ZORDER(Identifier).startWidth - 5, 21, 1, 0)
        ElseIf ZORDER(Identifier).isMaximized = -1 Then
            Call displayButton(ZORDER(Identifier).startWidth - 22, 4, ZORDER(Identifier).startWidth - 5, 21, 2, 0)
        End If
        If ZORDER(Identifier).isResizable = -1 Then
            Line (ZORDER(Identifier).startWidth - 23, ZORDER(Identifier).startHeight - 23)-(ZORDER(Identifier).startWidth - 1, ZORDER(Identifier).startHeight - 1), blackColor, B
            Call displayButton(ZORDER(Identifier).startWidth - 22, ZORDER(Identifier).startHeight - 22, ZORDER(Identifier).startWidth - 5, ZORDER(Identifier).startHeight - 5, 4, 0)
        End If
    ElseIf ZORDER(Identifier).isDialogBox = -1 Then
        Line (0, 0)-(ZORDER(Identifier).startWidth - 1, ZORDER(Identifier).startHeight - 1), blackColor, B
        Line (1, 1)-(ZORDER(Identifier).startWidth - 2, ZORDER(Identifier).startHeight - 2), windowBackgroundColor, BF
        If ZORDER(Identifier).isActive Then Line (1, 1)-(ZORDER(Identifier).startWidth - 2, ZORDER(Identifier).startHeight - 2), activeTitlebarColor, BF
        Line (4, 4)-(ZORDER(Identifier).startWidth - 5, ZORDER(Identifier).startHeight - 5), windowBackgroundColor, BF
        Call displayButton(5, 5, 22, 22, 6, 0)
        Line (23, 5)-(23, 23), blackColor
        Line (5, 23)-(23, 23), blackColor
        If ZORDER(Identifier).isActive = -1 Then Line (24, 5)-(ZORDER(Identifier).startWidth - 6, 23), activeTitlebarColor, BF
        Line (5, 23)-(ZORDER(Identifier).startWidth - 6, 23), blackColor
        Centering = (ZORDER(Identifier).startWidth - (30 + ZORDER(Identifier).titleTextSize)) / 2
        _PrintString (Centering + 23, 7), ZORDER(Identifier).Title
    End If
    drawInterface (Identifier)
    _Dest 0
End Sub

Sub displayButton (buttonStartX As _Unsigned Integer, buttonStartY As _Unsigned Integer, buttonEndX As _Unsigned Integer, buttonEndY As _Unsigned Integer, buttonTypeSelector As _Unsigned _Byte, buttonPressed As _Byte)
    If buttonTypeSelector <= 4 Then
        If buttonPressed = 0 Then
            Line (buttonStartX, buttonStartY)-(buttonEndX, buttonEndY), shadowColor2, B
            Line (buttonStartX, buttonStartY)-(buttonEndX - 1, buttonEndY - 1), highlightColor, B
            Line (buttonStartX + 1, buttonStartY + 1)-(buttonEndX - 1, buttonEndY - 1), shadowColor2, B
            Line (buttonStartX + 1, buttonStartY + 1)-(buttonEndX - 2, buttonEndY - 2), highlightColor, B
            Line (buttonStartX + 2, buttonStartY + 2)-(buttonEndX - 2, buttonEndY - 2), faceColor, BF
        ElseIf buttonPressed = -1 Then
            Line (buttonStartX, buttonStartY)-(buttonEndX, buttonEndY), highlightColor, B
            Line (buttonStartX, buttonStartY)-(buttonEndX - 1, buttonEndY - 1), shadowColor2, B
            Line (buttonStartX + 1, buttonStartY + 1)-(buttonEndX - 1, buttonEndY - 1), highlightColor, B
            Line (buttonStartX + 1, buttonStartY + 1)-(buttonEndX - 2, buttonEndY - 2), shadowColor2, B
            Line (buttonStartX + 2, buttonStartY + 2)-(buttonEndX - 2, buttonEndY - 2), faceColor, BF
        End If
    End If
    Select Case buttonTypeSelector
        Case Is = 0
        Case Is = 1
            Line (buttonStartX + 8, buttonStartY + 6)-(buttonStartX + 8, buttonStartY + 6), blackColor
            Line (buttonStartX + 7, buttonStartY + 7)-(buttonStartX + 9, buttonStartY + 7), blackColor
            Line (buttonStartX + 6, buttonStartY + 8)-(buttonStartX + 10, buttonStartY + 8), blackColor
            Line (buttonStartX + 5, buttonStartY + 9)-(buttonStartX + 11, buttonStartY + 9), blackColor
        Case Is = 2
            Line (buttonStartX + 8, buttonStartY + 4)-(buttonStartX + 8, buttonStartY + 4), blackColor
            Line (buttonStartX + 7, buttonStartY + 5)-(buttonStartX + 9, buttonStartY + 5), blackColor
            Line (buttonStartX + 6, buttonStartY + 6)-(buttonStartX + 10, buttonStartY + 6), blackColor
            Line (buttonStartX + 5, buttonStartY + 7)-(buttonStartX + 11, buttonStartY + 7), blackColor
            Line (buttonStartX + 5, buttonStartY + 10)-(buttonStartX + 11, buttonStartY + 10), blackColor
            Line (buttonStartX + 6, buttonStartY + 11)-(buttonStartX + 10, buttonStartY + 11), blackColor
            Line (buttonStartX + 7, buttonStartY + 12)-(buttonStartX + 9, buttonStartY + 12), blackColor
            Line (buttonStartX + 8, buttonStartY + 13)-(buttonStartX + 8, buttonStartY + 13), blackColor
        Case Is = 3
            Line (buttonStartX + 5, buttonStartY + 7)-(buttonStartX + 11, buttonStartY + 7), blackColor
            Line (buttonStartX + 6, buttonStartY + 8)-(buttonStartX + 10, buttonStartY + 8), blackColor
            Line (buttonStartX + 7, buttonStartY + 9)-(buttonStartX + 9, buttonStartY + 9), blackColor
            Line (buttonStartX + 8, buttonStartY + 10)-(buttonStartX + 8, buttonStartY + 10), blackColor
        Case Is = 4
            Line (buttonStartX + 4, buttonStartY + 12)-(buttonStartX + 12, buttonStartY + 12), blackColor
            Line (buttonStartX + 12, buttonStartY + 4)-(buttonStartX + 12, buttonStartY + 12), blackColor
            Line (buttonStartX + 4, buttonStartY + 10)-(buttonStartX + 10, buttonStartY + 10), blackColor
            Line (buttonStartX + 10, buttonStartY + 4)-(buttonStartX + 10, buttonStartY + 10), blackColor
        Case Is = 5
            Line (buttonStartX, buttonStartY)-(buttonEndX, buttonEndY), faceColor, BF
            Line (buttonStartX + 3, buttonStartY + 9)-(buttonStartX + 16, buttonStartY + 11), shadowColor, B
            Line (buttonStartX + 2, buttonStartY + 8)-(buttonStartX + 15, buttonStartY + 10), blackColor, B
            Line (buttonStartX + 3, buttonStartY + 9)-(buttonStartX + 14, buttonStartY + 9), whiteColor
        Case Is = 6
            Line (buttonStartX, buttonStartY)-(buttonEndX, buttonEndY), faceColor, BF
            Line (buttonStartX + 6, buttonStartY + 9)-(buttonStartX + 11, buttonStartY + 11), shadowColor, B
            Line (buttonStartX + 5, buttonStartY + 8)-(buttonStartX + 12, buttonStartY + 10), blackColor, B
            Line (buttonStartX + 6, buttonStartY + 9)-(buttonStartX + 11, buttonStartY + 9), whiteColor
    End Select
End Sub

Sub updateDisplay
    Dim Iteration As _Unsigned _Integer64
    Dim Temporary As _Unsigned Integer
    For Iteration = minimumSize + 1 To currentSize
        If ZORDER(Iteration).isMinimized = -1 Then
            _PutImage (ZORDER(Iteration).iconPositionStartX, ZORDER(Iteration).iconPositionStartY), ZORDER(Iteration).iconHandle
            Temporary = (ZORDER(Iteration).titleTextSize - ZORDER(Iteration).iconWidth) / 2
            ZORDER(Iteration).iconTitlePositionStartX = (ZORDER(Iteration).iconPositionStartX - Temporary + 2)
            ZORDER(Iteration).iconTitlePositionStartY = ((ZORDER(Iteration).iconPositionStartY + ZORDER(Iteration).iconHeight) + 6)
            Line ((ZORDER(Iteration).iconPositionStartX - Temporary), (ZORDER(Iteration).iconPositionStartY + ZORDER(Iteration).iconHeight) + 5)-(((ZORDER(Iteration).iconPositionStartX - Temporary) + (ZORDER(Iteration).titleTextSize) + 2), (ZORDER(Iteration).iconPositionStartY + ZORDER(Iteration).iconHeight) + 20), whiteColor, BF
            Line ((ZORDER(Iteration).iconPositionStartX - Temporary), (ZORDER(Iteration).iconPositionStartY + ZORDER(Iteration).iconHeight) + 5)-(((ZORDER(Iteration).iconPositionStartX - Temporary) + (ZORDER(Iteration).titleTextSize) + 2), (ZORDER(Iteration).iconPositionStartY + ZORDER(Iteration).iconHeight) + 20), blackColor, B
            Line ((ZORDER(Iteration).iconPositionStartX - Temporary), (ZORDER(Iteration).iconPositionStartY + ZORDER(Iteration).iconHeight) + 5)-(((ZORDER(Iteration).iconPositionStartX - Temporary) + (ZORDER(Iteration).titleTextSize) + 2), (ZORDER(Iteration).iconPositionStartY + ZORDER(Iteration).iconHeight) + 20), activeTitlebarColor, BF
            Color blackColor
            _PrintString (ZORDER(Iteration).iconTitlePositionStartX, ZORDER(Iteration).iconTitlePositionStartY), ZORDER(Iteration).Title
        ElseIf ZORDER(Iteration).isRestored = -1 Then
            Line (ZORDER(Iteration).positionStartX + shadowDepth, ZORDER(Iteration).positionStartY + shadowDepth)-((ZORDER(Iteration).positionStartX + ZORDER(Iteration).startWidth) + shadowDepth, (ZORDER(Iteration).positionStartY + ZORDER(Iteration).startHeight) + shadowDepth), windowShadowColor, BF
            _PutImage (ZORDER(Iteration).positionStartX, ZORDER(Iteration).positionStartY), ZORDER(Iteration).Handle
        ElseIf ZORDER(Iteration).isMaximized = -1 Then
            _PutImage (0, 0), ZORDER(Iteration).Handle
        End If
    Next Iteration
End Sub

Sub maximizeWindow (Identifier As _Unsigned _Integer64)
    If ZORDER(Identifier).isMaximizable = -1 Then
        ZORDER(Identifier).isMinimized = 0
        ZORDER(Identifier).isRestored = 0
        ZORDER(Identifier).isMaximized = -1
        Close ZORDER(Identifier).Handle
        ZORDER(Identifier).Handle = _NewImage(ZORDER(Identifier).maximumWidth, ZORDER(Identifier).maximumHeight, 32)
        displayWindow (Identifier)
    End If
End Sub

Sub minimizeWindow (Identifier As _Unsigned _Integer64)
    If ZORDER(Identifier).isRestored = -1 Then
        ZORDER(Identifier).wasRestored = -1
        ZORDER(Identifier).isRestored = 0
    ElseIf ZORDER(Identifier).isMaximized = -1 Then
        ZORDER(Identifier).wasMaximized = -1
        ZORDER(Identifier).isMaximized = 0
    End If
    ZORDER(Identifier).isMinimized = -1
End Sub

Sub restoreWindow (Identifier As _Unsigned _Integer64)
    If ZORDER(Identifier).isMaximized = -1 Then
        ZORDER(Identifier).isMaximized = 0
        ZORDER(Identifier).isRestored = -1
        Close ZORDER(Identifier).Handle
        ZORDER(Identifier).Handle = _NewImage(ZORDER(Identifier).startWidth, ZORDER(Identifier).startHeight, 32)
        displayWindow (Identifier)
    ElseIf ZORDER(Identifier).isMinimized = -1 And ZORDER(Identifier).wasRestored = -1 Then
        ZORDER(Identifier).wasRestored = 0
        ZORDER(Identifier).isMinimized = 0
        ZORDER(Identifier).isRestored = -1
    ElseIf ZORDER(Identifier).isMinimized = -1 And ZORDER(Identifier).wasMaximized = -1 Then
        ZORDER(Identifier).wasMaximized = 0
        maximizeWindow (Identifier)
    End If
    raiseToTop (Identifier)
End Sub

Sub moveWindow (Identifier As _Unsigned _Integer64)
    If ZORDER(Identifier).isMovable = -1 Then
        If ZORDER(Identifier).isMinimized = -1 And ZORDER(Identifier).isRestored = 0 Then
            ZORDER(Identifier).iconPositionPreviousX = (ZORDER(Identifier).iconPositionStartX - mouseX)
            ZORDER(Identifier).iconPositionPreviousY = (ZORDER(Identifier).iconPositionStartY - mouseY)
            While mouseButton1
                probeMouse
                If currentMouseX <> previousMouseX Or currentMouseY <> previousMouseY Then
                    ZORDER(Identifier).iconPositionStartX = (mouseX + ZORDER(Identifier).iconPositionPreviousX)
                    ZORDER(Identifier).iconPositionStartY = (mouseY + ZORDER(Identifier).iconPositionPreviousY)
                    bgPlace
                    updateDisplay
                    _Display
                End If
            Wend
        ElseIf ZORDER(Identifier).isRestored = -1 And ZORDER(Identifier).isMinimized = 0 Then
            ZORDER(Identifier).previousPositionX = (ZORDER(Identifier).positionStartX - mouseX)
            ZORDER(Identifier).previousPositionY = (ZORDER(Identifier).positionStartY - mouseY)
            While mouseButton1
                probeMouse
                If mouseX <> previousMouseX Or mouseY <> previousMouseY Then
                    ZORDER(Identifier).positionStartX = (mouseX + ZORDER(Identifier).previousPositionX)
                    ZORDER(Identifier).positionStartY = (mouseY + ZORDER(Identifier).previousPositionY)
                    bgPlace
                    updateDisplay
                    _Display
                End If
            Wend
        End If
    End If
End Sub

Sub resizeWindow (Identifier As _Unsigned _Integer64)
    If ZORDER(Identifier).isResizable = -1 Then
        Dim resizePositionStartX As _Unsigned Integer, resizePositionStartY As _Unsigned Integer
        resizePositionStartX = ZORDER(Identifier).positionStartX
        resizePositionStartY = ZORDER(Identifier).positionStartY
        Dim resizeWidth As _Unsigned Integer, resizeHeight As _Unsigned Integer
        resizeWidth = ZORDER(Identifier).startWidth
        resizeHeight = ZORDER(Identifier).startHeight
        Dim stuck As _Byte
        Do While mouseButton1
            probeMouse
            stuck = stuck Or 10
            If previousMouseX <> mouseX Or previousMouseY <> mouseY Then
                If Not isWithinArea(Identifier, resizePositionStartX, resizePositionStartY, resizeWidth, resizeHeight) Then
                    Select Case mouseX
                        Case mouseX <= resizePositionStartX
                            stuck = stuck Or 1
                        Case mouseX >= resizePositionStartX + resizeWidth
                            stuck = stuck Or 2
                    End Select
                    Select Case mouseY
                        Case mouseY <= resizePositionStartY
                            stuck = stuck Or 4
                        Case mouseY >= resizePositionStartY + resizeHeight
                            stuck = stuck Or 8
                    End Select
                End If
                If stuck And 1 Then
                    resizePositionStartX = mouseX
                    resizeWidth = ZORDER(Identifier).positionStartX + (ZORDER(Identifier).startWidth - mouseX)
                    If (resizeWidth - resizePositionStartX) <= 50 Then stuck = stuck Xor 1
                ElseIf stuck And 2 Then
                    resizePositionStartX = ZORDER(Identifier).positionStartX
                    resizeWidth = mouseX - ZORDER(Identifier).positionStartX
                    If (resizeWidth - resizePositionStartX) <= 50 Then stuck = stuck Xor 2
                End If
                If stuck And 4 Then
                    resizePositionStartY = mouseY
                    resizeHeight = ZORDER(Identifier).positionStartY + (ZORDER(Identifier).startHeight - mouseY)
                    If (resizeHeight - resizePositionStartY) <= 100 Then stuck = stuck Xor 4
                ElseIf stuck And 8 Then
                    resizePositionStartY = ZORDER(Identifier).positionStartY
                    resizeHeight = mouseY - ZORDER(Identifier).positionStartY
                    If (resizeHeight - resizePositionStartY) <= 100 Then stuck = stuck Xor 8
                End If
            End If
            previousMouseX = mouseX
            previousMouseY = mouseY
        Loop
        ZORDER(Identifier).positionStartX = resizePositionStartX
        ZORDER(Identifier).positionStartY = resizePositionStartY
        ZORDER(Identifier).startWidth = resizeWidth
        ZORDER(Identifier).startHeight = resizeHeight
        _FreeImage ZORDER(Identifier).Handle
        ZORDER(Identifier).Handle = _NewImage(ZORDER(Identifier).startWidth + 1, ZORDER(Identifier).startHeight + 1, 32)
        displayWindow (Identifier)
    End If
End Sub

Sub drawInterface (Identifier As _Unsigned _Integer64)
    Dim Indentation As _Unsigned Integer, Indentation2 As _Unsigned Integer, Indentation3 As _Unsigned Integer
    Dim textMessage1 As String, textMessage2 As String, textMessage9 As String
    Dim textMessage3 As String, textMessage4 As String, textMessage10 As String
    Dim textmessage5 As String, textMessage6 As String, textMessage11 As String
    Dim textmessage7 As String, textMessage8 As String, textMessage12 As String
    If ZORDER(Identifier).Identifier = 2 Then
        Dim icon2 As Long: icon2 = _LoadImage("./mines.png")
        If ZORDER(Identifier).isMaximized = -1 Then
            _PutImage (10, 30)-(ZORDER(Identifier).maximumWidth - 10, ZORDER(Identifier).maximumHeight - 10), icon2
            _FreeImage icon2
        ElseIf ZORDER(Identifier).isMaximized = 0 Then
            _PutImage (10, 30)-(ZORDER(Identifier).startWidth - 10, ZORDER(Identifier).startHeight - 10), icon2
            _FreeImage icon2
        End If
    ElseIf ZORDER(Identifier).Identifier = 3 Then
        Color blackColor
        Indentation = 15
        Indentation2 = Indentation * 13
        Indentation3 = Indentation * 25
        textMessage1 = " <| "
        textMessage2 = " <|<| "
        textMessage3 = " |<| "
        _PrintString (Indentation, 63), textMessage1
        _PrintString (Indentation, 93), textMessage2
        _PrintString (Indentation, 123), textMessage3
        textMessage4 = " |<|<| "
        textmessage5 = " |> "
        textMessage6 = " |>|> "
        _PrintString (Indentation2, 63), textMessage4
        _PrintString (Indentation2, 93), textmessage5
        _PrintString (Indentation2, 123), textMessage6
        textmessage7 = " |>|>| "
        textMessage8 = " () "
        textMessage9 = " [] "
        _PrintString (Indentation, 183), textmessage7
        _PrintString (Indentation, 213), textMessage8
        _PrintString (Indentation, 243), textMessage9
        textMessage10 = " |><| "
        Call displayButton(Indentation3, 125, Indentation3 + 100, 155, 0, 0)
        _PrintString (Indentation3 + 30, 133), textMessage10
    ElseIf ZORDER(Identifier).Identifier = 4 Then
        Color blackColor
        Indentation = 150
        textMessage1 = "Modular OS/3 V0.99a"
        textMessage2 = "Windowing System"
        textMessage3 = "(c) Keybone, 2017"
        _PrintString (Indentation, 63), textMessage1
        _PrintString (Indentation, 78), textMessage2
        _PrintString (Indentation, 93), textMessage3
        Dim icon4 As Long: icon4 = _LoadImage("./progman.png")
        _PutImage (50, 73)-(114, 137), icon4
        _FreeImage icon4
        textMessage4 = "OK"
        Call displayButton(165, 125, 265, 155, 0, 0)
        _PrintString (207, 133), textMessage4
    End If
End Sub

Sub checkInterface (Identifier As _Unsigned _Integer64)
    Select Case ZORDER(Identifier).Identifier
        Case 2
            If ZORDER(Identifier).isRestored Then
                Select Case ZORDER(Identifier).isResizable
                    Case -1
                        If isWithinArea(Identifier, 4, 30, ZORDER(Identifier).startWidth, ZORDER(Identifier).startHeight - 23) Then
                            switchToCLI
                        ElseIf isWithinArea(Identifier, 4, ZORDER(Identifier).startHeight - 22, ZORDER(Identifier).startWidth - 23, ZORDER(Identifier).startHeight - 5) Then
                            switchToCLI
                        End If
                    Case 0
                        If isWithinArea(Identifier, 4, 30, ZORDER(Identifier).startWidth - 5, ZORDER(Identifier).startHeight - 5) Then
                            switchToCLI
                        End If
                End Select
            End If
        Case 3
            Rem
        Case 4
            If isWithinArea(Identifier, 167, 127, 265, 155) Then
                removeFromZOrder (Identifier)
                If Identifier > minimumSize + 1 Then raiseToTop (Identifier - 1)
            End If
    End Select
End Sub

Sub switchToCLI
    Color whiteColor, blackColor: Cls
    cliMainLoop
End Sub

